<template>
  <form @submit.prevent="submitForm">
    <div class="form-group" :class="{invalid: !email.isValid}">
      <label for="email">Pseudo</label>
      <input
          class="form-control"
        type="email"
        id="email"
        v-model.trim="email.val"
        @blur="clearValidity('email')"
      />
      <p v-if="!email.isValid">email must not be empty.</p>
    </div>
    <div class="form-group" :class="{invalid: !password.isValid}">
      <label for="password">Mot de passe</label>
      <input
          class="form-control"
        type="password"
        id="password"
        v-model.trim="password.val"
        @blur="clearValidity('password')"
      />
      <p v-if="!password.isValid">password must not be empty.</p>
    </div>
    <p v-if="!formIsValid">Please fix the above errors and submit again.</p>
    <base-button class="mt-2">Connexion</base-button>
  </form>
</template>

<script>
export default {
  emits: ['save-data'],
  data() {
    return {
      email: {
        val: '',
        isValid: true,
      },
      password: {
        val: '',
        isValid: true,
      },
      formIsValid: true,
    };
  },
  methods: {
    clearValidity(input) {
      this[input].isValid = true;
    },
    validateForm() {
      this.formIsValid = true;
      if (this.email.val === '') {
        this.email.isValid = false;
        this.formIsValid = false;
      }
      if (this.password.val === '') {
        this.password.isValid = false;
        this.formIsValid = false;
      }
    },
    submitForm() {
      this.validateForm();

      if (!this.formIsValid) {
        return;
      }

      const formData = {
        email: this.email.val,
        password: this.password.val,

      };

      this.$emit('save-data', formData);
    },
  },
};
</script>

<style scoped>
</style>